commit 5debbeb03267103fd22809e8df341d1387334f52
Author: jklowden <jklowden>
Date:   Tue Sep 14 00:56:18 2010 +0000

    fix error-handler recursion

diff --git a/ChangeLog b/ChangeLog
index aafacb7..eae08ad 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Sep 13 20:53:12 EDT 2010	JK Lowden <jklowden@freetds.org>
+	* src/dblib/dblib.c fix error-handler recursion
+	* src/apps/tsql.c format errors better
+
 Mon Sep 13 18:32:55 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/sybdb.h src/dblib/dblib.c:
 	- patch from LacaK
@@ -2857,4 +2861,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3118 2010/09/13 16:38:21 freddy77 Exp $
+$Id: ChangeLog,v 1.3119 2010/09/14 00:56:18 jklowden Exp $
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 7539648..ce5ce4a 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.367 2010/09/13 16:39:28 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.368 2010/09/14 00:56:18 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -4841,7 +4841,9 @@ DBBOOL
 dbdead(DBPROCESS * dbproc)
 {
 	tdsdump_log(TDS_DBG_FUNC, "dbdead(%p) [%s]\n", dbproc, dbproc? IS_TDSDEAD(dbproc->tds_socket)? "dead":"alive" : "quite dead");
-	CHECK_PARAMETER(dbproc, SYBENULL, TRUE);
+
+	if( NULL == dbproc ) 
+		return TRUE;
 
 	if (IS_TDSDEAD(dbproc->tds_socket))
 		return TRUE;
@@ -4872,8 +4874,6 @@ dbdead(DBPROCESS * dbproc)
 static int
 default_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr)
 {
-	assert( ! (dbproc == NULL && DBDEAD(dbproc)) );  /* a non-process can't be a dead process */
-	
 	tdsdump_log(TDS_DBG_FUNC, "default_err_handler %p, %d, %d, %d, %p, %p", dbproc, severity, dberr, oserr, dberrstr, oserrstr);
 
 	if (DBDEAD(dbproc) && (!dbproc || !dbproc->msdblib)) {
@@ -7873,8 +7873,7 @@ dbperror (DBPROCESS *dbproc, DBINT msgno, long errnum, ...)
 	const DBLIB_ERROR_MESSAGE *msg = &default_message;
 	
 	int i, rc = INT_CANCEL;
-	char *os_msgtext = strerror(errnum), *rc_name;
-	char db_msgtext[32] = "INT_CANCEL"; 
+	char *os_msgtext = strerror(errnum), *rc_name = "logic error";
 
 	tdsdump_log(TDS_DBG_FUNC, "dbperror(%p, %d, %ld)\n", dbproc, msgno, errnum);	/* dbproc can be NULL */
 
@@ -7988,7 +7987,7 @@ dbperror (DBPROCESS *dbproc, DBINT msgno, long errnum, ...)
 		return rc;	/* normal case */
 		break;
 	default:
-		sprintf(db_msgtext, "%d", rc);
+		sprintf(rc_name, "%d", rc);
 		tdsdump_log(TDS_DBG_SEVERE, int_invalid_text, "Invalid return code", rc, msgno);
 		/* fall through */
 	case INT_EXIT:
@@ -7996,8 +7995,8 @@ dbperror (DBPROCESS *dbproc, DBINT msgno, long errnum, ...)
 			/* Microsoft behavior */
 			return INT_CANCEL;
 		}
-		fprintf(stderr, int_exit_text, db_msgtext, msgno);
-		tdsdump_log(TDS_DBG_SEVERE, int_exit_text, db_msgtext, msgno);
+		fprintf(stderr, int_exit_text, rc_name, msgno);
+		tdsdump_log(TDS_DBG_SEVERE, int_exit_text, rc_name, msgno);
 		break;
 	}
 	exit(EXIT_FAILURE);

